@ECHO off
setlocal

set time2=%time: =0%
set logdate=%date:~-10,4%%date:~-5,2%%date:~-2,2%

:start
IF "%~1" == "" goto finish
IF /i "%~x1" == ".mpg"  goto analyze
IF /i "%~x1" == ".mpeg"  goto analyze
IF /i "%~x1" == ".mp4"  goto analyze
IF /i "%~x1" == ".avi"  goto analyze
IF /i "%~x1" == ".wmv"  goto analyze
goto error

:analyze
set fnd=C:\demux\Codec.txt
set fn=C:\demux\temp.txt
C:\demux\MediaInfo.exe -f %1 > %fn%
find "Codecs Video" %fn% > %fnd%
del %fn%

find /i "WMV" %fnd%
IF %ERRORLEVEL%==0 goto wmv

find /i "VC-1" %fnd%
IF %ERRORLEVEL%==0 goto wmv

find /i "DivX" %fnd%
IF %ERRORLEVEL%==0 goto avi

find /i "XviD" %fnd%
IF %ERRORLEVEL%==0 goto avi

find /i "VP6" %fnd%
IF %ERRORLEVEL%==0 goto avi

find /i "Cinepack" %fnd%
IF %ERRORLEVEL%==0 goto avi

find /i "MS Video" %fnd%
IF %ERRORLEVEL%==0 goto avi

find /i "MPEG-4 Visual" %fnd%
IF %ERRORLEVEL%==0 goto avi

find /i "S-Mpeg 4 v2" %fnd%
IF %ERRORLEVEL%==0 goto avi

find /i "MPEG" %fnd%
IF %ERRORLEVEL%==0 goto mpg_check

find /i "AVC" %fnd%
IF %ERRORLEVEL%==0 goto mp4

goto error

:mp4
del %fnd%
C:\demux\MP4Box.exe -raw 1 %1
C:\demux\MP4Box.exe -raw 2 %1
C:\demux\MP4Box.exe -raw 3 %1
ren "%~dpn1_track?.h264" %~n1_track1.h264
C:\demux\DtsEdit.exe %1 -o "%~dp1timecode.txt"
ren "%~dpnx1" "%~nx1.bak"
C:\demux\MP4Box.exe -add "%~dpn1_track1.h264"#video -new "%~dpn1_pre.mp4"
C:\demux\DtsEdit.exe -tc "%~dp1timecode.txt" "%~dpn1_pre.mp4" -o "%~dpn1.mp4"
del "%~dpn1_track*" "%~dp1timecode.txt" "%~dpn1_pre.mp4"
ren "%~dpn1.mp4" "%~nx1"
IF exist "%~dpnx1" (goto sizecheck) else (goto error)

:mpg_check
C:\demux\MediaInfo.exe -f %1 > %fn%
find "Format/Extensions usually used" %fn% > %fnd%
find /i "m2v" %fnd%
IF %ERRORLEVEL%==0 goto m2v

:m1v
C:\demux\ffmpeg.exe -y -i %1 -vcodec copy "%~dpn1.m1v"
ren "%~dpnx1" "%~nx1.bak"
ren "%~dpn1.m1v" "%~nx1"
IF exist "%~dpnx1" (goto sizecheck) else (goto error)

:m2v
C:\demux\ffmpeg.exe -y -i %1 -vcodec copy "%~dpn1.m2v"
ren "%~dpnx1" "%~nx1.bak"
ren "%~dpn1.m2v" "%~nx1"
IF exist "%~dpnx1" (goto sizecheck) else (goto error)

:avi

C:\demux\ffmpeg.exe -y -i %1 -vcodec copy -an "%~dpn1_v.avi"
ren "%~dpnx1" "%~nx1.bak"
ren "%~dpn1_v.avi" "%~nx1"
IF exist "%~dpnx1" (goto sizecheck) else (goto error)

:wmv
C:\demux\ffmpeg.exe -y -i %1 -vcodec copy -an "%~dpn1_v.wmv"
ren "%~dpnx1" "%~nx1.bak"
ren "%~dpn1_v.wmv" "%~nx1"
IF exist "%~dpnx1" (goto sizecheck) else (goto error)


:error
IF exist "%~dpnx1.bak" (ren "%~dpnx1.bak" %~nx1)
echo %~dpnx1,Ή>C:\demux\error_%logdate%.log
SHIFT
goto start

:sizecheck
for %%A in ("%~dpnx1") do for %%B in ("%~dpnx1.bak") do if %%~zA EQU %%~zB (goto delbackup) else (goto codec_check)

:codec_check
C:\demux\MediaInfo.exe -f %1 > %fn%
find "Codecs Video" %fn%
IF %ERRORLEVEL%==0 goto next
del %1
ren "%~dpnx1.bak" "%~nx1"
echo %~dpnx1,s>C:\demux\error_%logdate%.log
SHIFT
goto start

:delbackup
del "%~dpnx1.bak"
SHIFT
goto start

:next
SHIFT
goto start

:finish
IF exist %fnd% (del %fnd%)
IF exist %fn% (del %fn%)